/* C code produced by gperf version 2.7.2 */
/* Command-line: gperf -c -N lookup_keyword -t -D keywords.gperf  */
/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 918 $ $LastChangedDate: 2002-09-10 09:49:07 +0200 (Tue, 10 Sep 2002) $
 *
 * Keyword.gperf - List of keyword recognised by Gont compiler.
 */

#include "parser.h"
#include <string.h>
struct keyword;
struct keyword *lookup_keyword(const char*, unsigned int);
struct keyword { char *name; int tok; };

#define TOTAL_KEYWORDS 42
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 10
#define MIN_HASH_VALUE 4
#define MAX_HASH_VALUE 108
/* maximum key range = 105, duplicates = 2 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static unsigned char asso_values[] =
    {
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109,  10,  15,  10,
       20,   0,  25,  20,  15,  15, 109,   0,  30, 109,
       56,  25,  15, 109,  40,  45,   5,   0,   0,   0,
      109,   0, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109, 109, 109, 109, 109,
      109, 109, 109, 109, 109, 109
    };
  return len + asso_values[(unsigned char)str[len - 1]] + asso_values[(unsigned char)str[0]];
}

#ifdef __GNUC__
__inline
#endif
struct keyword *
lookup_keyword (str, len)
     register const char *str;
     register unsigned int len;
{
  static struct keyword wordlist[] =
    {
      {"else", KW_ELSE},
      {"while", KW_WHILE},
      {"try", KW_TRY},
      {"true", KW_TRUE},
      {"type", KW_TYPE},
      {"case", KW_CASE},
      {"continue", KW_CONTINUE},
      {"with", KW_WITH},
      {"break", KW_BREAK},
      {"int", KW_INT},
      {"void", KW_VOID},
      {"false", KW_FALSE},
      {"finally", KW_FINALLY},
      {"float", KW_FLOAT},
      {"object", KW_OBJECT},
      {"typedef", KW_TYPEDEF},
      {"let", KW_LET},
      {"opt_struct", KW_OPT_STRUCT},
      {"if", KW_IF},
      {"raise", KW_RAISE},
      {"do", KW_DO},
      {"def", KW_DEF},
      {"bool", KW_BOOL},
      {"this", KW_THIS},
      {"struct", KW_STRUCT},
      {"as", KW_AS},
      {"new", KW_NEW},
      {"class", KW_CLASS},
      {"union", KW_UNION},
      {"extern", KW_EXTERN},
      {"skip", KW_SKIP},
      {"exception", KW_EXCEPTION},
      {"namespace", KW_NAMESPACE},
      {"switch", KW_SWITCH},
      {"for", KW_FOR},
      {"string", KW_STRING},
      {"in", KW_IN},
      {"fun", KW_FUN},
      {"open", KW_OPEN},
      {"null", KW_NULL},
      {"return", KW_RETURN},
      {"section", KW_SECTION}
    };

  static short lookup[] =
    {
        -1,   -1,   -1,   -1,    0,    1,   -1,   -1,
         2,  -53,  -39,   -2,   -1,   -1,    5,   -1,
        -1,   -1,    6,    7,    8,   -1,   -1,    9,
        10,   -1,   -1,   -1,   -1,   -1,   11,   -1,
        12,   -1,   -1,   13,   14,   15,   16,   -1,
        17,   -1,   18,   -1,   -1,   19,   -1,   20,
        21,   22,   -1,   -1,   -1,   -1,   23,   -1,
        24,   25,   -1,   26,   27,   28,   29,   -1,
        30, -112,   33,   -1,   34,  -11,   -2,   35,
        -1,   36,   -1,   -1,   -1,   -1,   -1,   -1,
        -1,   -1,   -1,   -1,   37,   38,   -1,   -1,
        -1,   -1,   39,   -1,   -1,   -1,   -1,   -1,
        -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
        -1,   -1,   -1,   -1,   41
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register int index = lookup[key];

          if (index >= 0)
            {
              register const char *s = wordlist[index].name;

              if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                return &wordlist[index];
            }
          else if (index < -TOTAL_KEYWORDS)
            {
              register int offset = - 1 - TOTAL_KEYWORDS - index;
              register struct keyword *wordptr = &wordlist[TOTAL_KEYWORDS + lookup[offset]];
              register struct keyword *wordendptr = wordptr + -lookup[offset + 1];

              while (wordptr < wordendptr)
                {
                  register const char *s = wordptr->name;

                  if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                    return wordptr;
                  wordptr++;
                }
            }
        }
    }
  return 0;
}
