// Test basic pattern matching
// $Rev: 884 $ $LastChangedDate: 2002-09-07 17:00:45 +0200 (Sat, 07 Sep 2002) $

void f(int x)
{
	switch (x) {
	case 1:
		print_string("one ");
	case 2:
		print_string("two ");
	case _:
		print_string("HGW ");
	}
}

void pp(*(int, int) x)
{
	switch (x) {
	case (1, 1):
		print_string("(one,one) ");
		
	case (1, v):
		print_string("(one,");
		print_int(v);
		print_string(") ");
		
	case (u, v):
		print_string("(");
		print_int(u);
		print_string(",");
		print_int(v);
		print_string(") ");
	}
}

section init
{
        if (1 == 1)
		print_string("ok ");
	f(1);
	f(2);
	f(3);
	pp((1,1));
	pp((1,2));
	pp((2,3));
	print_string(".\n");
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: ok one two HGW (one,one) (one,2) (2,3) .
 */
